jjb: lttng-tools: Update discard strategy of the gerrit job
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
5a196804 1#!/bin/bash -exu
f3d8604b 2#
1d5a0a3c 3# Copyright (C) 2016-2019 - Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
39961776
MJ
18# Parameters
19arch=${arch:-}
20cross_arch=${cross_arch:-}
21ktag=${ktag:-}
5a196804
MJ
22kgitrepo=${kgitrepo:-}
23mversion=${mversion:-}
24mgitrepo=${mgitrepo:-}
39961776
MJ
25
26
339db64d
MJ
27## FUNCTIONS ##
28
f3d8604b
MJ
29# Kernel version compare functions
30verlte() {
51fa2ab3 31 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
32}
33
34verlt() {
28b10e79 35 # shellcheck disable=SC2015
51fa2ab3 36 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
37}
38
39vergte() {
51fa2ab3 40 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
41}
42
43vergt() {
28b10e79 44 # shellcheck disable=SC2015
51fa2ab3 45 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
46}
47
339db64d 48
5a196804
MJ
49git_clone_modules_sources() {
50 mkdir -p "$MODULES_GIT_DIR"
28b10e79
MJ
51
52 # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
53 # as a branch name.
54 if [ "${mversion:0:5}" = "refs/" ]; then
55 git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
56 (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
57 else
58 git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
59 fi
5a196804
MJ
60}
61
62# Checkout a shallow kernel tree of the specified tag
63git_clone_linux_sources() {
64 mkdir -p "$LINUX_GIT_DIR"
65 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
66}
7e02032c 67
7e02032c 68
5a196804
MJ
69# Export the kernel sources from the git repo
70git_export_linux_sources() {
71 cd "$LINUX_GIT_DIR"
72 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
73}
74
75
76# Upload the tar archive to the object store
77upload_archive_obj() {
78 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
79 rm -f "$WORKSPACE/$obj_name"
80}
81
82
83extract_archive_obj() {
84 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
85 rm -f "$WORKSPACE/$obj_name"
86}
87
88
89tar_archive_obj() {
90 cd "$LINUX_OBJ_DIR"
91 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
92 cd -
93}
94
95# Find the most recent GCC version supported by the kernel sources
96select_compiler() {
97 local selected_cc
98
99 cd "$LINUX_SRCOBJ_DIR"
100
101 kversion=$(make -s kernelversion)
102
103 set +e
104
1d5a0a3c 105 for cc in gcc-5 gcc-4.8; do
5a196804
MJ
106 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
107 selected_cc="$cc"
108 break
109 fi
110 done
111
112 set -e
113
114 if [ "x$selected_cc" = "x" ]; then
115 echo "Found no suitable compiler."
116 exit 1
117 fi
118
1d5a0a3c
MJ
119 # Force gcc-4.8 for kernels before 3.18
120 if { verlt "$kversion" "3.18"; }; then
23db2292 121 selected_cc=gcc-4.8
7e02032c
MJ
122 fi
123
425e4992
MJ
124 if [ "$selected_cc" != "gcc-4.8" ]; then
125 # Older kernel Makefiles do not expect the compiler to default to PIE
126 KAFLAGS="-fno-pie"
c45b04df 127 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
128 KCPPFLAGS="-fno-pie"
129 export KAFLAGS KCFLAGS KCPPFLAGS
130 fi
131
5a196804 132 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 133 export HOSTCC="${selected_cc}"
5a196804
MJ
134
135 cd -
136}
137
138
139build_linux_kernel() {
140 cd "$LINUX_SRCOBJ_DIR"
141
142 kversion=$(make -s kernelversion)
143
7e02032c 144 # Generate kernel configuration
a1ae361e 145 case "$ktag" in
7e02032c 146 Ubuntu*)
39961776 147 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 148 if vergte "${kversion}" "4.10"; then
39961776
MJ
149 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
150 exit 0
151 fi
152 fi
a46abb0a
MJ
153 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
154 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
5a196804 155 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 156 ;;
c45b04df 157
7e02032c 158 *)
16844a6d
MJ
159 # Force 32bit build on i386, default is 64bit
160 if [ "$arch" = "i386" ]; then
5a196804
MJ
161 export ARCH="i386"
162 fi
163
164 # allyesconfig is mostly broken for kernels of the 2.6 series
165 if verlt "$kversion" "3.0"; then
166 vanilla_config="defconfig"
7a76a4d0
MJ
167 fi
168
5a196804 169 make "${vanilla_config}"
7e02032c
MJ
170 ;;
171 esac
172
53b51a15 173 # oldnoconfig was renamed in 4.19
5a196804 174 if vergte "$kversion" "4.19"; then
53b51a15 175 update_conf_target="olddefconfig"
5a196804 176 else
53b51a15 177 update_conf_target="oldnoconfig"
5a196804
MJ
178 fi
179
180 # Fix 'defined(@array)' was removed from recent perl
181 if [ -f "kernel/timeconst.pl" ]; then
182 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
183 fi
184
185 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
53b51a15 186 if [ "$HOSTCC" != "gcc-4.8" ]; then
5a196804
MJ
187 if [ -f "arch/x86/kvm/svm.c" ]; then
188 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
189 fi
190
191 if [ -f "arch/x86/kvm/vmx.c" ]; then
192 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
193 fi
194 fi
195
53b51a15
MJ
196 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
197 # Convert them to 'cmpw' which was previously done silently
198 if verlt "$kversion" "4.9"; then
199 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
200 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
201 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
202 fi
203
5a196804
MJ
204 # Fix a typo in v2.6.36.x
205 if [ -f "arch/x86/kernel/entry_64.S" ]; then
206 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
207 fi
208
53b51a15
MJ
209 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
210 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
211 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
212 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
213 fi
214
5a196804
MJ
215 # Fix kernel < 3.0 with gcc >= 4.7
216 if verlt "$kversion" "3.0"; then
217 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
218 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
219 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
220 echo "header-y += linkage.h" >> include/linux/Kbuild
221 fi
222
7e02032c 223 # GCC 4.8
53b51a15
MJ
224 if [ "$HOSTCC" == "gcc-4.8" ]; then
225 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
226 fi
7e02032c
MJ
227
228 # Don't try to sign modules
53b51a15 229 scripts/config --disable CONFIG_MODULE_SIG
7e02032c 230
9ef18fa2 231 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
53b51a15 232 scripts/config --disable CONFIG_STACK_VALIDATION
5a196804
MJ
233
234 # Cause problems with inline assembly on i386
53b51a15 235 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
5a196804 236
1d5a0a3c 237 # Don't build samples, they are broken on some kernel releases
53b51a15
MJ
238 scripts/config --disable CONFIG_SAMPLES
239 scripts/config --disable CONFIG_BUILD_DOCSRC
c45b04df
MJ
240
241 # Disable kcov
53b51a15 242 scripts/config --disable CONFIG_KCOV
c45b04df
MJ
243
244 # Broken on some RT kernels
53b51a15 245 scripts/config --disable CONFIG_HYPERV
1d5a0a3c 246
1e300ea9 247 # Broken drivers
53b51a15
MJ
248 scripts/config --disable CONFIG_RAPIDIO_TSI721
249 scripts/config --disable CONFIG_SGI_XP
250 scripts/config --disable CONFIG_MFD_WM8994
251 scripts/config --disable CONFIG_DRM_RADEON
252 scripts/config --disable CONFIG_SND_SOC_WM5100
1e300ea9 253
5a196804
MJ
254 # IGBVF won't build with recent gcc on 2.6.38.x
255 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
53b51a15 256 scripts/config --disable CONFIG_IGBVF
5a196804 257 fi
9ef18fa2 258
51fa2ab3 259 # Set required options
53b51a15
MJ
260 scripts/config --enable CONFIG_TRACEPOINTS
261 scripts/config --enable CONFIG_KALLSYMS
262 scripts/config --enable CONFIG_HIGH_RES_TIMERS
263 scripts/config --enable CONFIG_KPROBES
264 scripts/config --enable CONFIG_FTRACE
265 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
266 scripts/config --enable CONFIG_KALLSYMS_ALL
267 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
268 scripts/config --enable CONFIG_PERF_EVENTS
269 scripts/config --enable CONFIG_EVENT_TRACING
270 scripts/config --enable CONFIG_KRETPROBES
7e02032c 271
7a76a4d0 272 # Debug
5a196804
MJ
273 #cat .config
274
275 make "$update_conf_target" CC="$CC"
276 make -j"$NPROC" CC="$CC"
277
c45b04df 278 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
279
280 # Save the kernel and modules
281 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
53b51a15
MJ
282 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install CC="$CC"
283 make INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install CC="$CC"
5a196804
MJ
284 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
285 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
286 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
287}
288
289
290extract_distro_headers() {
291
292 # Enter linux source dir
293 cd "${LINUX_SRCOBJ_DIR}"
294
295
296 # For RT kernels, copy version file
297 if [ -s localversion-rt ]; then
298 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
299 fi
300
301 # Copy all Makefile related stuff
302 find . -path './include/*' -prune \
303 -o -path './scripts/*' -prune -o -type f \
304 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
305 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
306 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
307
308 # Copy base scripts and include dirs
309 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 310
5a196804
MJ
311 # Copy arch includes
312 (find arch -name include -type d -print0 | \
313 xargs -0 -n1 -i: find : -type f) | \
314 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
315
316 # Copy arch scripts
317 (find arch -name scripts -type d -print0 | \
318 xargs -0 -n1 -i: find : -type f) | \
319 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
320
321 # Cleanup scripts
322 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
323 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
324
04873cc3 325 # On powerpc 32bits this object is required to link modules
5a196804 326 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
327 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
328 :
329 else
04873cc3
MJ
330 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
331 fi
5a196804
MJ
332 fi
333
334 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
335 if [ "${karch}" = "arm64" ]; then
336 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
337 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
338 fi
339 fi
340
341 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
342 if [ -f tools/objtool/objtool ]; then
343 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
344 fi
345
346 if [ -f "arch/x86/kernel/macros.s" ]; then
347 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
348 fi
349
350 # Copy modules related stuff, if available
351 if [ -s Module.symvers ]; then
352 cp Module.symvers "${LINUX_HDROBJ_DIR}"
353 fi
354
355 if [ -s System.map ]; then
356 cp System.map "${LINUX_HDROBJ_DIR}"
357 fi
358
359 if [ -s Module.markers ]; then
360 cp Module.markers "${LINUX_HDROBJ_DIR}"
361 fi
362
363 # Copy config file
364 cp .config "${LINUX_HDROBJ_DIR}"
365
366 # Make sure the Makefile and version.h have a matching timestamp so that
367 # external modules can be built
368 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
369 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
370 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
371 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
372 else
373 echo "Missing version.h"
374 exit 1
375 fi
376 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
377
378 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
379 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
380
381 # Finally clean the object files from the full source tree
382 make clean
383
384 # And regen the modules support files
385 make modules_prepare CC="$CC"
51fa2ab3 386
04873cc3 387 # On powerpc 32bits this object is required to link modules
d815b018 388 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
389 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
390 :
391 else
04873cc3
MJ
392 make arch/powerpc/lib/crtsavres.o CC="$CC"
393 fi
d815b018
MJ
394 fi
395
7a76a4d0 396 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 397 if [ "${karch}" = "arm64" ]; then
c236528e 398 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 399 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
400 fi
401 fi
402
7e02032c 403 # Version specific tasks
a1ae361e 404 case "$ktag" in
7e02032c
MJ
405 Ubuntu*)
406 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 407 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
408 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
409 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
410 ;;
411 esac
7e02032c
MJ
412}
413
414
339db64d
MJ
415build_modules() {
416
5a196804
MJ
417 local kdir="$1"
418 local outdir="$2"
419 local kversion
420
421 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 422
339db64d 423 # Enter lttng-modules source dir
5a196804 424 cd "${MODULES_GIT_DIR}"
339db64d
MJ
425
426 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
427 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
428 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
429 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
430
431 set +e
432
433 # Build modules
51fa2ab3 434 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
0f71a764 435 ret=$?
339db64d 436
5a196804
MJ
437 set -e
438
339db64d 439 # We expect this build to fail, if it doesn't, fail the job.
0f71a764 440 if [ "$ret" -eq 0 ]; then
e9b44189 441 echo "This build should have failed."
339db64d
MJ
442 exit 1
443 fi
444
445 # We have to publish at least one file or the build will fail
5a196804 446 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d 447
5a196804 448 KERNELDIR="${kdir}" make clean
7e02032c 449
339db64d
MJ
450 else # Regular build
451
452 # Build modules against full kernel sources
51fa2ab3 453 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
454
455 # Install modules to build dir
5a196804 456 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
457
458 # Clean build dir
5a196804 459 KERNELDIR="${kdir}" make clean
339db64d
MJ
460 fi
461}
462
463
464## MAIN ##
465
f3d8604b
MJ
466# Use all CPU cores
467NPROC=$(nproc)
468
5a196804
MJ
469MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
470LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 471
5a196804
MJ
472LINUX_OBJ_DIR="${WORKSPACE}/linux"
473LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
474LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
475LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 476
5a196804
MJ
477MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
478MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 479
5a196804
MJ
480LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
481
482OBJ_STORE_URL="s3://jenkins"
483
484cd "$WORKSPACE"
485
486# Create build directories
487mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
488
489git_clone_modules_sources
339db64d 490
7e02032c 491# Setup cross compile env if available
39961776 492if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
493
494 case "$cross_arch" in
495 "armhf")
496 karch="arm"
497 cross_compile="arm-linux-gnueabihf-"
53b51a15 498 vanilla_config="imx_v6_v7_defconfig"
7e02032c
MJ
499 ubuntu_config="armhf-config.flavour.generic"
500 ;;
501
502 "arm64")
503 karch="arm64"
504 cross_compile="aarch64-linux-gnu-"
53b51a15 505 vanilla_config="defconfig"
7e02032c
MJ
506 ubuntu_config="arm64-config.flavour.generic"
507 ;;
508
509 "powerpc")
510 karch="powerpc"
511 cross_compile="powerpc-linux-gnu-"
e9b44189 512 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
513 ubuntu_config="powerpc-config.flavour.powerpc-smp"
514 ;;
515
516 "ppc64el")
517 karch="powerpc"
518 cross_compile="powerpc64le-linux-gnu-"
e9b44189 519 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
520 ubuntu_config="ppc64el-config.flavour.generic"
521 ;;
522
523 *)
51fa2ab3 524 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
525 exit 1
526 ;;
527 esac
339db64d 528
7e02032c
MJ
529 # Export variables used by Kbuild for cross compilation
530 export ARCH="${karch}"
531 export CROSS_COMPILE="${cross_compile}"
339db64d 532
7e02032c 533# Set arch specific values if we are not cross compiling
39961776 534elif [ "x${arch}" != "x" ]; then
e9b44189 535
7e02032c 536 case "$arch" in
16844a6d 537 "i386")
7e02032c 538 karch="x86"
e9b44189 539 vanilla_config="allyesconfig"
7e02032c
MJ
540 ubuntu_config="i386-config.flavour.generic"
541 ;;
542
16844a6d 543 "amd64")
7e02032c 544 karch="x86"
e9b44189 545 vanilla_config="allyesconfig"
7e02032c
MJ
546 ubuntu_config="amd64-config.flavour.generic"
547 ;;
548
549 "armhf")
550 karch="arm"
e9b44189 551 vanilla_config="allyesconfig"
7e02032c
MJ
552 ubuntu_config="armhf-config.flavour.generic"
553 ;;
554
555 "arm64")
556 karch="arm64"
e9b44189 557 vanilla_config="allyesconfig"
7e02032c
MJ
558 ubuntu_config="arm64-config.flavour.generic"
559 ;;
560
561 "powerpc")
562 karch="powerpc"
e9b44189 563 vanilla_config="allyesconfig"
7e02032c
MJ
564 ubuntu_config="powerpc-config.flavour.powerpc-smp"
565 ;;
566
567 "ppc64el")
568 karch="powerpc"
e9b44189 569 vanilla_config="allyesconfig"
7e02032c
MJ
570 ubuntu_config="ppc64el-config.flavour.generic"
571 ;;
572
573 *)
574 echo "Unsupported arch $arch"
575 exit 1
576 ;;
577 esac
578else
04873cc3 579 echo "No arch or cross_arch specified"
7e02032c
MJ
580 exit 1
581fi
339db64d 582
339db64d 583
b214d997 584
5a196804
MJ
585# First get the kernel build from the object store, or build it, if it's
586# not available.
339db64d 587
5a196804
MJ
588echo "# Setup endpoint
589host_base = obj.internal.efficios.com
590host_bucket = obj.internal.efficios.com
591bucket_location = us-east-1
592use_https = True
7e02032c 593
5a196804
MJ
594# Setup access keys
595access_key = jenkins
596secret_key = echo123456
339db64d 597
5a196804
MJ
598# Enable S3 v4 signature APIs
599signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 600
c45b04df 601url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 602obj_name="linux.tar.bz2"
c45b04df 603obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/$arch/${cross_arch:-native}"
5a196804 604obj_url="$obj_url_prefix/$obj_name"
339db64d 605
5a196804
MJ
606set +e
607s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
608ret=$?
609set -e
339db64d 610
5a196804
MJ
611case "$ret" in
612 "0")
613 extract_archive_obj
614 ;;
a1ae361e 615
5a196804
MJ
616 "12")
617 echo "File not found"
339db64d 618
5a196804
MJ
619 # Build all the things and upload
620 # then finish the module build...
339db64d 621
5a196804
MJ
622 git_clone_linux_sources
623 git_export_linux_sources
339db64d 624
5a196804 625 select_compiler
a1ae361e 626
5a196804
MJ
627 ## PREPARE FULL LINUX SOURCE TREE
628 build_linux_kernel
d138fc44 629
5a196804
MJ
630 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
631 extract_distro_headers
339db64d 632
5a196804 633 tar_archive_obj
339db64d 634
5a196804 635 upload_archive_obj
339db64d 636
5a196804 637 ;;
339db64d 638
5a196804
MJ
639 *)
640 echo "Unknown error? Abort"
641 exit 1
642 ;;
643esac
339db64d 644
5a196804 645select_compiler
f3d8604b 646
7e02032c 647## BUILD modules
5a196804
MJ
648# Either we downloaded a pre-build kernel or we built it and uploaded
649# the archive for future builds.
650
651cd "$WORKSPACE"
f3d8604b 652
339db64d 653# Build modules against full kernel sources
5a196804 654build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 655
339db64d 656# Build modules against kernel headers
5a196804 657build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 658
5a196804
MJ
659# Make sure some modules were actually built
660tree "${MODULES_OUTPUT_KSRC_DIR}"
661if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
662 echo "No modules built!"
663 exit 1
664fi
665
5a196804
MJ
666tree "${MODULES_OUTPUT_KHDR_DIR}"
667if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
668 echo "No modules built!"
669 exit 1
670fi
b214d997 671
f3d8604b 672# EOF
This page took 0.05992 seconds and 4 git commands to generate.